function CObstacle(oSprite){
    var _iMinHeight;
    var _iMaxHeight;
    var _iHalfWidth;
    var _iLastObjIndex;
    var _iLastObjPassedByHero;
    var _iCont;
    var _aObstacles;
    var _oSprite;
    
    this._init = function(oSprite){
         _iCont = 0;
         _oSprite = oSprite;

        _iMinHeight = -Math.floor(oSprite.height/5);
        _iMaxHeight = Math.floor(oSprite.height/5);
        _iHalfWidth = oSprite.width/2;

        this._initLevel();
    };
	
	this.unload = function(){
        for(var i=0;i<_aObstacles;i++){
             s_oStage.addChild(_aObstacles[i]);
        }
    };
    
    this._initLevel = function(){
        var iXPos = CANVAS_WIDTH + oSprite.width; 
        var iRandHeight = Math.floor(randomFloatBetween(_iMinHeight,_iMaxHeight));
        _aObstacles = new Array();  
        while(iXPos < (CANVAS_WIDTH*2)+ oSprite.width){
            //PUT TOP OBSTACLE 
            var oObstacle = new createjs.Bitmap(oSprite);
            oObstacle.x = iXPos;
            oObstacle.y = iRandHeight;   
            oObstacle.regX = oSprite.width/2;
            oObstacle.regY = oSprite.height/2;
            s_oStage.addChild(oObstacle);
            
            _aObstacles.push(oObstacle);

            //PUT DOWN OBSTACLE
            oObstacle = new createjs.Bitmap(oSprite);
            oObstacle.x = iXPos;
            oObstacle.y = iRandHeight + (oSprite.height) + OBSTACLE_HEIGHT_DIST;   
            oObstacle.regX = oSprite.width/2;
            oObstacle.regY = oSprite.height/2;
            oObstacle.scaleY = -1;
            s_oStage.addChild(oObstacle);
            _aObstacles.push(oObstacle);
            
            iXPos += DIST_AMONG_OBSTACLES;
            
            iRandHeight = this.assignNextHeight(iRandHeight);
        }
        
        _iLastObjIndex = _aObstacles.length-1;
        _iLastObjPassedByHero = -1;
    };
    
    this.restartLevel = function(){
        
        var iXPos = CANVAS_WIDTH + oSprite.width; 
        var iRandHeight = Math.floor(randomFloatBetween(_iMinHeight,_iMaxHeight));
  
         for(var i=0;i<_aObstacles.length;i+=2){     
            //PUT TOP OBSTACLE 

            _aObstacles[i].x = iXPos;
            _aObstacles[i].y = iRandHeight;   

            //PUT DOWN OBSTACLE

            _aObstacles[i+1].x = iXPos;
            _aObstacles[i+1].y = iRandHeight + (oSprite.height) + OBSTACLE_HEIGHT_DIST;   

            iXPos += DIST_AMONG_OBSTACLES;
            
            iRandHeight = this.assignNextHeight(iRandHeight);
        }
        
        _iLastObjIndex = _aObstacles.length-1;
        _iLastObjPassedByHero = -1;
    };
    
    this.assignNextHeight = function(iPrevHeight){
        var iNewMinValue = iPrevHeight - TOLERANCE_NEXT_OBST_HEIGHT;
        if(iNewMinValue<_iMinHeight){
            iNewMinValue = _iMinHeight;
        }

        var iNewMaxValue = iPrevHeight + TOLERANCE_NEXT_OBST_HEIGHT;
        if(iNewMaxValue>_iMaxHeight){
            iNewMaxValue = _iMaxHeight;
        }

        return Math.floor(randomFloatBetween(iNewMinValue,iNewMaxValue));
    };
    

   this._checkCollision = function(oHero,iObstacle){
       return checkRectCollision(oHero,_aObstacles[iObstacle]);
    };

    this.update = function(oHero,iSpeed){
        for(var i=0;i<_aObstacles.length;i+=2){     
            if(_aObstacles[i].x < -_iHalfWidth){
                 _aObstacles[i].x = _aObstacles[_iLastObjIndex].x + _iHalfWidth + DIST_AMONG_OBSTACLES;
                 _aObstacles[i+1].x = _aObstacles[_iLastObjIndex].x + _iHalfWidth + DIST_AMONG_OBSTACLES;
                 
                 _aObstacles[i].y = this.assignNextHeight(_aObstacles[_iLastObjIndex].y);
                 _aObstacles[i+1].y = _aObstacles[i].y + (oSprite.height) + OBSTACLE_HEIGHT_DIST;   
                 
                 _iLastObjIndex = i;
            }
            _aObstacles[i].x -=  iSpeed;
            _aObstacles[i+1].x -=  iSpeed;
            
            if( this._checkCollision(oHero,i) || this._checkCollision(oHero,i+1)){
                s_oGame.collisionFound();
                break;
            }
            
            if( _iLastObjPassedByHero !== i && _aObstacles[i].x < HERO_START_X){
                _iLastObjPassedByHero = i;
                s_oGame.increaseScore();
            }
        }
    };
    
    this._init(oSprite);
}